<?php
if (defined('_PS_CLASS_DIR_')) {
    require_once _PS_CLASS_DIR_ . '/order/Order.php';
}

if (defined('_PS_MODULE_DIR_')) {
    require_once _PS_MODULE_DIR_ . '/expay/events/payserver_event_check.php';
    require_once _PS_MODULE_DIR_ . '/expay/events/payserver_event_pay.php';
    require_once _PS_MODULE_DIR_ . '/expay/classes/payserver_logger.php';
}

class PayserverEventHandler
{
    private $payserver_logger;

    public function __construct()
    {
        $this->payserver_logger = new PayserverLogger();
    }

    public function handle($event)
    {

        if (!isset($event['method'])) {
            $this->payserver_logger->add('Expay Webhooks: Invalid webhook request:' . json_encode($event));
            return false;
        }

        switch ($event['method']) {
            case 'check':
                $message = 'Expay Webhooks: an event CHECK (order#' . $event['order'] . ') has been caught.';
                $this->payserver_logger->add($message);
                $payserver_event = new PayserverEventCheck();
                break;

            case 'pay':
                $message = 'Expay Webhooks: an event PAY (order#' . $event['order'] . ') has been caught.';

                $this->payserver_logger->add($message);
                $payserver_event = new PayserverEventPay();
                break;

            default:
                return false;
        }

        return $payserver_event->handle($event);
    }
}